/*
  date_time_numeric.hpp

  Copyright (C) 2011 Taiji Yamada <taiji@aihara.co.jp>
 */
#ifndef _DATE_TIME_NUMERIC_HPP
#define _DATE_TIME_NUMERIC_HPP
#include <boost/date_time.hpp>

inline
const unsigned long operator/(const boost::gregorian::date_duration &a, const boost::gregorian::date_duration &b)
{
  return a.days()/b.days();
}
inline
const boost::gregorian::date_duration operator*(const boost::gregorian::date_duration &a, const unsigned long b)
{
  return boost::gregorian::date_duration(a.days()*b);
}

inline
const unsigned long operator/(const boost::gregorian::date_duration &a, const boost::gregorian::years &b)
{
  return a.days()/(b.number_of_years().as_number()*365.25);
}

inline
const unsigned long operator/(const boost::gregorian::date_duration &a, const boost::gregorian::months &b)
{
  return a.days()/(b.number_of_months().as_number()*30.4);
}

inline
const unsigned long operator/(const boost::gregorian::date_duration &a, const boost::gregorian::weeks &b)
{
  return a.days()/b.days();
}

inline
const unsigned long operator/(const boost::posix_time::time_duration &a, const boost::posix_time::time_duration &b)
{
  return (a.total_seconds() + 1e-9*a.total_microseconds())/(b.total_seconds() + 1e-9*b.total_microseconds());
}
#endif
